From 5bb28ba2ca17b0b4b59d15a8301fcf7167f905db Mon Sep 17 00:00:00 2001
From: mlx93 <mylesethan93@gmail.com>
Date: Mon, 24 Nov 2025 22:49:09 -0600
Subject: [PATCH] Add native PIVOT syntax support for SQL Server/Oracle
 compatibility

Implement PIVOT clause transformation in the PostgreSQL parser, allowing
queries like:

  SELECT region
  FROM sales
  PIVOT (SUM(revenue) FOR quarter IN ('Q1', 'Q2', 'Q3', 'Q4'))
  ORDER BY region;

The pivot columns (Q1, Q2, Q3, Q4) are automatically generated from the
IN list. The implementation transforms PIVOT into standard SQL using
aggregate functions with FILTER clauses and implicit GROUP BY.

Aggregate validation uses catalog lookup to support any valid aggregate
function, including user-defined aggregates.

Key behaviors:
- SELECT * is disallowed (explicit column list required)
- GROUP BY is disallowed (implicit from non-pivot columns)
- Duplicate pivot values produce an error
- Works with CTEs, subqueries, JOINs, and views
---
 doc/src/sgml/queries.sgml           |  165 ++++
 src/backend/parser/analyze.c        |   82 +-
 src/backend/parser/gram.y           |  111 ++-
 src/backend/parser/parse_clause.c   |  566 +++++++++++++
 src/backend/utils/adt/ruleutils.c   |  197 +++++
 src/include/nodes/parsenodes.h      |   39 +
 src/include/parser/kwlist.h         |    1 +
 src/include/parser/parse_clause.h   |    3 +
 src/include/parser/parse_node.h     |    2 +
 src/test/regress/expected/pivot.out | 1168 +++++++++++++++++++++++++++
 src/test/regress/parallel_schedule  |    5 +
 src/test/regress/sql/pivot.sql      |  789 ++++++++++++++++++
 12 files changed, 3117 insertions(+), 11 deletions(-)
 create mode 100644 src/test/regress/expected/pivot.out
 create mode 100644 src/test/regress/sql/pivot.sql

diff --git a/doc/src/sgml/queries.sgml b/doc/src/sgml/queries.sgml
index 4b522213171..29f71204f83 100644
--- a/doc/src/sgml/queries.sgml
+++ b/doc/src/sgml/queries.sgml
@@ -931,6 +931,171 @@ WHERE pname IS NULL;
 </programlisting>
     </para>
    </sect3>
+
+   <sect3 id="queries-pivot">
+    <title><literal>PIVOT</literal></title>
+
+    <indexterm zone="queries-pivot">
+     <primary>PIVOT</primary>
+    </indexterm>
+
+    <para>
+     The <literal>PIVOT</literal> clause provides a declarative way to rotate
+     rows into columns, applying an aggregate function to create the pivoted
+     values.  This is commonly used in reporting and analytics to transform
+     normalized data into a cross-tabulation format.  The syntax is:
+<synopsis>
+<replaceable>table_reference</replaceable> PIVOT ( <replaceable>aggregate_function</replaceable>(<replaceable>value_column</replaceable>) FOR <replaceable>pivot_column</replaceable> IN (<replaceable>value1</replaceable>, <replaceable>value2</replaceable>, ...) )
+</synopsis>
+    </para>
+
+    <para>
+     This syntax is compatible with Microsoft SQL Server (since 2005) and
+     Oracle Database (since 11g).  For reference, see
+     <ulink url="https://learn.microsoft.com/en-us/sql/t-sql/queries/from-using-pivot-and-unpivot">SQL Server PIVOT documentation</ulink>
+     and
+     <ulink url="https://docs.oracle.com/en/database/oracle/oracle-database/19/sqlrf/SELECT.html">Oracle SELECT documentation</ulink>.
+    </para>
+
+    <para>
+     The <literal>PIVOT</literal> clause works as follows:
+     <orderedlist>
+      <listitem>
+       <para>
+        The columns in the <command>SELECT</command> list (excluding the
+        pivot column) become the <quote>row identifiers</quote> and are
+        implicitly grouped.
+       </para>
+      </listitem>
+      <listitem>
+       <para>
+        For each value specified in the <literal>IN</literal> list, the
+        aggregate function is applied with a filter condition matching
+        that value, producing a new output column.
+       </para>
+      </listitem>
+      <listitem>
+       <para>
+        The output column names are derived from the pivot values, quoted
+        as identifiers.
+       </para>
+      </listitem>
+     </orderedlist>
+    </para>
+
+    <para>
+     For example, given a <literal>sales</literal> table with columns
+     <literal>region</literal>, <literal>quarter</literal>, and
+     <literal>revenue</literal>, this query:
+<programlisting>
+SELECT region
+FROM sales
+PIVOT (SUM(revenue) FOR quarter IN ('Q1', 'Q2', 'Q3', 'Q4'))
+ORDER BY region;
+</programlisting>
+     produces output with columns <literal>region</literal>,
+     <literal>"Q1"</literal>, <literal>"Q2"</literal>,
+     <literal>"Q3"</literal>, and <literal>"Q4"</literal>, where each
+     quarter column contains the sum of revenue for that quarter.
+    </para>
+
+    <para>
+     Internally, <productname>PostgreSQL</productname> transforms the
+     <literal>PIVOT</literal> clause into equivalent <literal>FILTER</literal>
+     aggregate expressions.  The above query is equivalent to:
+<programlisting>
+SELECT region,
+       SUM(revenue) FILTER (WHERE quarter = 'Q1') AS "Q1",
+       SUM(revenue) FILTER (WHERE quarter = 'Q2') AS "Q2",
+       SUM(revenue) FILTER (WHERE quarter = 'Q3') AS "Q3",
+       SUM(revenue) FILTER (WHERE quarter = 'Q4') AS "Q4"
+FROM sales
+GROUP BY region
+ORDER BY region;
+</programlisting>
+    </para>
+
+    <para>
+     Any aggregate function can be used with <literal>PIVOT</literal>,
+     including user-defined aggregates.  Common aggregates include
+     <function>SUM</function>, <function>COUNT</function>,
+     <function>AVG</function>, <function>MIN</function>, and
+     <function>MAX</function>.  For <function>COUNT(*)</function>,
+     omit the value column:
+<programlisting>
+SELECT region
+FROM sales
+PIVOT (COUNT(*) FOR quarter IN ('Q1', 'Q2', 'Q3', 'Q4'));
+</programlisting>
+    </para>
+
+    <para>
+     Multiple row identifier columns can be specified in the
+     <command>SELECT</command> list:
+<programlisting>
+SELECT region, product
+FROM sales
+PIVOT (SUM(revenue) FOR quarter IN ('Q1', 'Q2', 'Q3', 'Q4'))
+ORDER BY region, product;
+</programlisting>
+    </para>
+
+    <para>
+     The following restrictions apply to <literal>PIVOT</literal>:
+     <itemizedlist>
+      <listitem>
+       <para>
+        <literal>SELECT *</literal> cannot be used with
+        <literal>PIVOT</literal>.  You must explicitly specify the
+        row identifier columns.
+       </para>
+      </listitem>
+      <listitem>
+       <para>
+        An explicit <literal>GROUP BY</literal> clause cannot be used
+        with <literal>PIVOT</literal>, as the grouping is automatically
+        derived from the row identifiers.
+       </para>
+      </listitem>
+      <listitem>
+       <para>
+        Duplicate values in the <literal>IN</literal> list are not
+        allowed.
+       </para>
+      </listitem>
+      <listitem>
+       <para>
+        Pivot values that would conflict with row identifier column
+        names are not allowed.
+       </para>
+      </listitem>
+     </itemizedlist>
+    </para>
+
+    <para>
+     <literal>PIVOT</literal> can be used with subqueries, CTEs, and
+     joins as the source table:
+<programlisting>
+WITH quarterly_totals AS (
+    SELECT region, quarter, SUM(revenue) AS revenue
+    FROM sales
+    GROUP BY region, quarter
+)
+SELECT region
+FROM quarterly_totals
+PIVOT (SUM(revenue) FOR quarter IN ('Q1', 'Q2', 'Q3', 'Q4'))
+ORDER BY region;
+</programlisting>
+    </para>
+
+    <note>
+     <para>
+      For more complex pivoting needs, such as dynamic pivot columns
+      determined at runtime, consider using the <function>crosstab</function>
+      function from the <xref linkend="tablefunc"/> module.
+     </para>
+    </note>
+   </sect3>
   </sect2>
 
   <sect2 id="queries-where">
diff --git a/src/backend/parser/analyze.c b/src/backend/parser/analyze.c
index 7843a0c857e..6f8ddcf98a2 100644
--- a/src/backend/parser/analyze.c
+++ b/src/backend/parser/analyze.c
@@ -1446,6 +1446,61 @@ transformSelectStmt(ParseState *pstate, SelectStmt *stmt,
 	else
 		markTargetListOrigins(pstate, qry->targetList);
 
+	/*
+	 * If PIVOT clause was specified in FROM, transform it now.
+	 * This must happen after transformTargetList but before GROUP BY handling
+	 * because PIVOT generates its own GROUP BY and aggregates.
+	 *
+	 * First, check for SELECT * which is not allowed with PIVOT.
+	 * SELECT * cannot be used with PIVOT because the transformation needs to
+	 * know at parse time which columns are row identifiers (to be grouped by)
+	 * versus which columns will be replaced by pivoted aggregates. With SELECT *,
+	 * we cannot determine this mapping since the expansion happens dynamically
+	 * and would include the pivot column itself in the output.
+	 */
+	if (pstate->p_pivot_clause != NULL)
+	{
+		ListCell   *lc;
+
+		/*
+		 * Detect SELECT * by checking the original statement's targetList
+		 * for A_Star nodes in ColumnRef fields.
+		 */
+		foreach(lc, stmt->targetList)
+		{
+			ResTarget  *rt = (ResTarget *) lfirst(lc);
+
+			if (IsA(rt->val, ColumnRef))
+			{
+				ColumnRef  *cr = (ColumnRef *) rt->val;
+				Node	   *lastField = llast(cr->fields);
+
+				if (IsA(lastField, A_Star))
+					ereport(ERROR,
+							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+							 errmsg("SELECT * is not allowed with PIVOT"),
+							 errhint("Specify the columns you want in the SELECT list."),
+							 parser_errposition(pstate, pstate->p_pivot_clause->location)));
+			}
+		}
+
+		/*
+		 * Check for explicit GROUP BY - not allowed with PIVOT.
+		 * PIVOT automatically generates GROUP BY from row identifiers.
+		 */
+		if (stmt->groupClause != NIL)
+		{
+			ereport(ERROR,
+					(errcode(ERRCODE_SYNTAX_ERROR),
+					 errmsg("PIVOT cannot be combined with explicit GROUP BY"),
+					 errhint("PIVOT automatically generates GROUP BY from row identifiers."),
+					 parser_errposition(pstate, pstate->p_pivot_clause->location)));
+		}
+
+		/* Now perform the PIVOT transformation */
+		transformPivotClause(pstate, qry);
+	}
+
 	/* transform WHERE */
 	qual = transformWhereClause(pstate, stmt->whereClause,
 								EXPR_KIND_WHERE, "WHERE");
@@ -1466,16 +1521,23 @@ transformSelectStmt(ParseState *pstate, SelectStmt *stmt,
 										  EXPR_KIND_ORDER_BY,
 										  false /* allow SQL92 rules */ );
 
-	qry->groupClause = transformGroupClause(pstate,
-											stmt->groupClause,
-											stmt->groupByAll,
-											&qry->groupingSets,
-											&qry->targetList,
-											qry->sortClause,
-											EXPR_KIND_GROUP_BY,
-											false /* allow SQL92 rules */ );
-	qry->groupDistinct = stmt->groupDistinct;
-	qry->groupByAll = stmt->groupByAll;
+	/*
+	 * Skip transformGroupClause if PIVOT was used - PIVOT already set up
+	 * qry->groupClause with the appropriate row identifiers.
+	 */
+	if (pstate->p_pivot_clause == NULL)
+	{
+		qry->groupClause = transformGroupClause(pstate,
+												stmt->groupClause,
+												stmt->groupByAll,
+												&qry->groupingSets,
+												&qry->targetList,
+												qry->sortClause,
+												EXPR_KIND_GROUP_BY,
+												false /* allow SQL92 rules */ );
+		qry->groupDistinct = stmt->groupDistinct;
+		qry->groupByAll = stmt->groupByAll;
+	}
 
 	if (stmt->distinctClause == NIL)
 	{
diff --git a/src/backend/parser/gram.y b/src/backend/parser/gram.y
index c3a0a354a9c..9136a507417 100644
--- a/src/backend/parser/gram.y
+++ b/src/backend/parser/gram.y
@@ -137,6 +137,13 @@ typedef struct KeyActions
 	KeyAction *deleteAction;
 } KeyActions;
 
+/* PivotAggregate - helper struct for passing aggregate info in PIVOT clause */
+typedef struct PivotAggregate
+{
+	List	   *aggName;		/* aggregate function name (qualified) */
+	Node	   *valueColumn;	/* column to aggregate, NULL for COUNT(*) */
+} PivotAggregate;
+
 /* ConstraintAttributeSpec yields an integer bitmask of these flags: */
 #define CAS_NOT_DEFERRABLE			0x01
 #define CAS_DEFERRABLE				0x02
@@ -556,6 +563,9 @@ static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);
 %type <range>	extended_relation_expr
 %type <range>	relation_expr_opt_alias
 %type <node>	tablesample_clause opt_repeatable_clause
+%type <node>	pivot_clause
+%type <list>	pivot_value_list
+%type <node>	pivot_value pivot_aggregate
 %type <target>	target_el set_target insert_column_item
 
 %type <str>		generic_option_name
@@ -763,7 +773,7 @@ static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);
 	OVER OVERLAPS OVERLAY OVERRIDING OWNED OWNER
 
 	PARALLEL PARAMETER PARSER PARTIAL PARTITION PASSING PASSWORD PATH
-	PERIOD PLACING PLAN PLANS POLICY
+	PERIOD PIVOT PLACING PLAN PLANS POLICY
 	POSITION PRECEDING PRECISION PRESERVE PREPARE PREPARED PRIMARY
 	PRIOR PRIVILEGES PROCEDURAL PROCEDURE PROCEDURES PROGRAM PUBLICATION
 
@@ -13748,6 +13758,15 @@ table_ref:	relation_expr opt_alias_clause
 					n->relation = (Node *) $1;
 					$$ = (Node *) n;
 				}
+			| relation_expr opt_alias_clause pivot_clause
+				{
+					RangePivot *n = (RangePivot *) $3;
+
+					$1->alias = $2;
+					/* relation_expr goes inside the RangePivot node */
+					n->source = (Node *) $1;
+					$$ = (Node *) n;
+				}
 			| func_table func_alias_clause
 				{
 					RangeFunction *n = (RangeFunction *) $1;
@@ -13789,6 +13808,18 @@ table_ref:	relation_expr opt_alias_clause
 					n->alias = $2;
 					$$ = (Node *) n;
 				}
+			| select_with_parens opt_alias_clause pivot_clause
+				{
+					RangePivot *n = (RangePivot *) $3;
+					RangeSubselect *rs = makeNode(RangeSubselect);
+
+					rs->lateral = false;
+					rs->subquery = $1;
+					rs->alias = $2;
+					/* RangeSubselect goes inside the RangePivot node */
+					n->source = (Node *) rs;
+					$$ = (Node *) n;
+				}
 			| LATERAL_P select_with_parens opt_alias_clause
 				{
 					RangeSubselect *n = makeNode(RangeSubselect);
@@ -14143,6 +14174,82 @@ opt_repeatable_clause:
 			| /*EMPTY*/					{ $$ = NULL; }
 		;
 
+/*
+ * PIVOT clause - transforms rows to columns using aggregation
+ *
+ * Syntax: PIVOT (agg_func(value_col) FOR pivot_col IN (value1, value2, ...)) [AS alias]
+ *
+ * The pivot_clause rule returns a RangePivot node with the source set to NULL;
+ * the source relation is attached by the table_ref production.
+ */
+pivot_clause:
+			PIVOT '(' pivot_aggregate FOR ColId IN_P '(' pivot_value_list ')' ')' opt_alias_clause
+				{
+					PivotClause *pc = makeNode(PivotClause);
+					PivotAggregate *pa = (PivotAggregate *) $3;
+
+					pc->aggName = pa->aggName;
+					pc->valueColumn = pa->valueColumn;
+					pc->pivotColumn = $5;
+					pc->pivotValues = $8;
+					pc->alias = $11;
+					pc->location = @1;
+
+					RangePivot *rp = makeNode(RangePivot);
+					rp->source = NULL;	/* filled in by table_ref production */
+					rp->pivot = pc;
+					rp->alias = $11;
+					rp->location = @1;
+					$$ = (Node *) rp;
+				}
+		;
+
+/*
+ * pivot_aggregate - the aggregate function call in a PIVOT clause
+ *
+ * This is a simplified aggregate syntax: func_name(column) or func_name(*)
+ */
+pivot_aggregate:
+			func_name '(' '*' ')'
+				{
+					PivotAggregate *n = (PivotAggregate *) palloc(sizeof(PivotAggregate));
+					n->aggName = $1;
+					n->valueColumn = NULL;	/* COUNT(*) style */
+					$$ = (Node *) n;
+				}
+			| func_name '(' columnref ')'
+				{
+					PivotAggregate *n = (PivotAggregate *) palloc(sizeof(PivotAggregate));
+					n->aggName = $1;
+					n->valueColumn = (Node *) $3;
+					$$ = (Node *) n;
+				}
+		;
+
+pivot_value_list:
+			pivot_value							{ $$ = list_make1($1); }
+			| pivot_value_list ',' pivot_value	{ $$ = lappend($1, $3); }
+		;
+
+pivot_value:
+			Sconst
+				{
+					$$ = (Node *) makeStringConst($1, @1);
+				}
+			| Iconst
+				{
+					$$ = (Node *) makeIntConst($1, @1);
+				}
+			| FCONST
+				{
+					$$ = (Node *) makeFloatConst($1, @1);
+				}
+			| Sconst TYPECAST Typename
+				{
+					$$ = makeTypeCast(makeStringConst($1, @1), $3, @2);
+				}
+		;
+
 /*
  * func_table represents a function invocation in a FROM list. It can be
  * a plain function call, like "foo(...)", or a ROWS FROM expression with
@@ -18279,6 +18386,7 @@ type_func_name_keyword:
 			| NOTNULL
 			| OUTER_P
 			| OVERLAPS
+			| PIVOT
 			| RIGHT
 			| SIMILAR
 			| TABLESAMPLE
@@ -18672,6 +18780,7 @@ bare_label_keyword:
 			| PASSWORD
 			| PATH
 			| PERIOD
+			| PIVOT
 			| PLACING
 			| PLAN
 			| PLANS
